function f = se_llf(theta,fun,fname)

% This function computes the s.e. for parameters estimated using MLE.

chg(1:length(theta)) = 1e-6;
chg(1) = 1e-4; chg(2) = 1e-3; chg(3) = 1e-3;
nvars = length(theta);
f0 = feval(fun, theta,1,fname);
nobs = size(f0,1);
g = zeros(nobs,nvars);
f1 = zeros(nobs);
for i=1:nvars
    t1 = theta;
    t1(i) = t1(i) + chg(i);
    f1 = feval(fun, t1, 1,fname);
    g(:,i) = (f1 - f0)/chg(i);
end
gbar = mean(g);

V2 = inv((g - ones(size(g,1),1)*gbar)'*(g-ones(size(g,1),1)*gbar));

% Accounting for error due to first steps of estimation
nsizes = 4;
h = zeros(nobs,nsizes);
f1 = zeros(nobs);
fname1 = ['s2'; 's4'; 's6'; 's8'];
for i=1:nsizes
        s2 = [fname1(i,:) fname(3:5)];
        f1 = feval(fun, theta,1,s2);
        h(:,i) = (f1 - f0)/0.5;
end
hbar = mean(h);

C = (g - ones(size(g,1),1)*gbar)'*(h-ones(size(h,1),1)*hbar);

load v1
v1 = min(100, v1);
s2 = ['load dwdtheta' fname(5) '.txt'];
eval(s2)
s2 = ['dwdtheta = dwdtheta' fname(5) ';'];
eval(s2)
V1 = dwdtheta*v1*dwdtheta';

f = V2 + V2*C*V1*C'*V2;